*** a/doc/src/sgml/catalogs.sgml
--- b/doc/src/sgml/catalogs.sgml
***************
*** 352,358 ****
        <entry><structfield>aggtransfn</structfield></entry>
        <entry><type>regproc</type></entry>
        <entry><literal><link linkend="catalog-pg-proc"><structname>pg_proc</structname></link>.oid</literal></entry>
!       <entry>Transition function</entry>
       </row>
       <row>
        <entry><structfield>aggfinalfn</structfield></entry>
--- 352,358 ----
        <entry><structfield>aggtransfn</structfield></entry>
        <entry><type>regproc</type></entry>
        <entry><literal><link linkend="catalog-pg-proc"><structname>pg_proc</structname></link>.oid</literal></entry>
!       <entry>Transition function (zero if none)</entry>
       </row>
       <row>
        <entry><structfield>aggfinalfn</structfield></entry>
***************
*** 370,376 ****
        <entry><structfield>aggtranstype</structfield></entry>
        <entry><type>oid</type></entry>
        <entry><literal><link linkend="catalog-pg-type"><structname>pg_type</structname></link>.oid</literal></entry>
!       <entry>Data type of the aggregate function's internal transition (state) data</entry>
       </row>
       <row>
        <entry><structfield>agginitval</structfield></entry>
--- 370,394 ----
        <entry><structfield>aggtranstype</structfield></entry>
        <entry><type>oid</type></entry>
        <entry><literal><link linkend="catalog-pg-type"><structname>pg_type</structname></link>.oid</literal></entry>
!       <entry>Data type of the aggregate function's internal transition (state) data (zero if none)</entry>
!      </row>
!      <row>
!       <entry><structfield>aggtranssortop</structfield></entry>
!       <entry><type>oid</type></entry>
!       <entry><literal><link linkend="catalog-pg-operator"><structname>pg_operator</structname></link>.oid</literal></entry>
!       <entry>An optional sort operator for the type "aggtranstype", used for some kinds of ordered set functions</entry>
!      </row>
!      <row>
!       <entry><structfield>aggordnargs</structfield></entry>
!       <entry><type>int4</type></entry>
!       <entry></entry>
!       <entry>Number of direct arguments to ordered set function; -2 for hypothetical set functions; -1 for ordinary aggregates.</entry>
!      </row>
!      <row>
!       <entry><structfield>aggisordsetfunc</structfield></entry>
!       <entry><type>bool</type></entry>
!       <entry></entry>
!       <entry>A flag to represent whether a function is ordered set or not</entry>
       </row>
       <row>
        <entry><structfield>agginitval</structfield></entry>
*** a/doc/src/sgml/func.sgml
--- b/doc/src/sgml/func.sgml
***************
*** 12197,12202 **** SELECT xmlagg(x) FROM (SELECT x FROM test ORDER BY y DESC) AS tab;
--- 12197,12453 ----
  
   </sect1>
  
+  <sect1 id="functions-ordered">
+   <title>Ordered Set Functions</title>
+ 
+   <indexterm zone="functions-ordered">
+    <primary>ordered set function</primary>
+    <secondary>built-in</secondary>
+   </indexterm>
+ 
+   <para>
+    <firstterm>Ordered set functions</firstterm> compute a single result
+    from an ordered set of input values.  The built-in ordered set functions
+    are listed in
+    <xref linkend="functions-inversedist-table"> and
+    <xref linkend="functions-hypothetical-table">.
+    The special syntax considerations for ordered set functions
+    are explained in <xref linkend="syntax-orderedset">.
+   </para>
+ 
+   <table id="functions-inversedist-table">
+    <title>Inverse Distribution Functions</title>
+ 
+    <tgroup cols="5">
+     <thead>
+      <row>
+       <entry>Function</entry>
+       <entry>Direct Argument Type(s)</entry>
+       <entry>Ordered Argument Type(s)</entry>
+       <entry>Return Type</entry>
+       <entry>Description</entry>
+      </row>
+     </thead>
+ 
+     <tbody>
+ 
+      <row>
+       <entry>
+        <indexterm>
+         <primary>percentile</primary>
+         <secondary>discrete</secondary>
+        </indexterm>
+        <function>percentile_disc(<replaceable class="parameter">fraction</replaceable>) WITHIN GROUP (ORDER BY <replaceable class="parameter">sort_expression</replaceable>)</function>
+       </entry>
+       <entry>
+        <type>double precision</type> (must be [0..1])
+       </entry>
+       <entry>
+        any sortable type
+       </entry>
+       <entry>
+        same as sort expression
+       </entry>
+       <entry>
+         discrete percentile; returns the first result whose position in
+         the ordering equals or exceeds the specified fraction
+       </entry>
+      </row>
+ 
+      <row>
+       <entry>
+        <indexterm>
+         <primary>percentile</primary>
+         <secondary>discrete</secondary>
+        </indexterm>
+        <function>percentile_disc(<replaceable class="parameter">fractions</replaceable>) WITHIN GROUP (ORDER BY <replaceable class="parameter">sort_expression</replaceable>)</function>
+       </entry>
+       <entry>
+        <type>double precision[]</type> (all must be [0..1] or null)
+       </entry>
+       <entry>
+        any sortable type
+       </entry>
+       <entry>
+        array of input type
+       </entry>
+       <entry>
+         multiple discrete percentile; returns an array of results matching the
+         shape of the <literal>fractions</literal> parameter, with each
+         non-null element replaced by the input value at that percentile
+       </entry>
+      </row>
+ 
+      <row>
+       <entry>
+        <indexterm>
+         <primary>percentile</primary>
+         <secondary>continuous</secondary>
+        </indexterm>
+        <indexterm>
+         <primary>median</primary>
+        </indexterm>
+        <function>percentile_cont(<replaceable class="parameter">fraction</replaceable>) WITHIN GROUP (ORDER BY <replaceable class="parameter">sort_expression</replaceable>)</function>
+       </entry>
+       <entry>
+        <type>double precision</type> (must be [0..1])
+       </entry>
+       <entry>
+        <type>double precision</type> or <type>interval</type>
+       </entry>
+       <entry>
+        same as sort expression
+       </entry>
+       <entry>
+         continuous percentile; interpolates between adjacent items.
+       </entry>
+      </row>
+ 
+      <row>
+       <entry>
+        <indexterm>
+         <primary>percentile</primary>
+         <secondary>continuous</secondary>
+        </indexterm>
+        <function>percentile_cont(<replaceable class="parameter">fractions</replaceable>) WITHIN GROUP (ORDER BY <replaceable class="parameter">sort_expression</replaceable>)</function>
+       </entry>
+       <entry>
+        <type>double precision[]</type> (all must be [0..1] or null)
+       </entry>
+       <entry>
+        <type>double precision</type> or <type>interval</type>
+       </entry>
+       <entry>
+        array of input type
+       </entry>
+       <entry>
+         multiple continuous percentile; returns an array of results matching
+         the shape of the <literal>fractions</literal> parameter, with each
+         non-null element replaced by the value corresponding to that percentile
+       </entry>
+      </row>
+ 
+      <row>
+       <entry>
+        <indexterm>
+         <primary>mode</primary>
+         <secondary>statistical</secondary>
+        </indexterm>
+        <function>mode() WITHIN GROUP (ORDER BY <replaceable class="parameter">sort_expression</replaceable>)</function>
+       </entry>
+       <entry>
+       </entry>
+       <entry>
+        any sortable type
+       </entry>
+       <entry>
+        same as sort expression
+       </entry>
+       <entry>
+        returns the most frequent input value (choosing one arbitrarily if
+        there are multiple equally good result)
+       </entry>
+      </row>
+ 
+     </tbody>
+    </tgroup>
+   </table>
+ 
+   <para>
+    All the inverse distribution functions ignore null values in their sorted
+    input.  The <replaceable>fraction</replaceable> parameter must be between 0
+    and 1; an error is thrown if not.  However, a null fraction simply produces
+    a null result.
+   </para>
+ 
+   <table id="functions-hypothetical-table">
+    <title>Hypothetical Set Functions</title>
+ 
+    <tgroup cols="3">
+     <thead>
+      <row>
+       <entry>Function</entry>
+       <entry>Return Type</entry>
+      </row>
+     </thead>
+ 
+     <tbody>
+ 
+      <row>
+       <entry>
+        <indexterm>
+         <primary>rank</primary>
+         <secondary>hypothetical</secondary>
+        </indexterm>
+        <function>rank(<replaceable class="parameter">args</replaceable>) WITHIN GROUP (ORDER BY <replaceable class="parameter">sorted_args</replaceable>)</function>
+       </entry>
+       <entry>
+        <type>bigint</type>
+       </entry>
+      </row>
+ 
+      <row>
+       <entry>
+        <indexterm>
+         <primary>dense_rank</primary>
+         <secondary>hypothetical</secondary>
+        </indexterm>
+        <function>dense_rank(<replaceable class="parameter">args</replaceable>) WITHIN GROUP (ORDER BY <replaceable class="parameter">sorted_args</replaceable>)</function>
+       </entry>
+       <entry>
+        <type>bigint</type>
+       </entry>
+      </row>
+ 
+      <row>
+       <entry>
+        <indexterm>
+         <primary>percent_rank</primary>
+         <secondary>hypothetical</secondary>
+        </indexterm>
+        <function>percent_rank(<replaceable class="parameter">args</replaceable>) WITHIN GROUP (ORDER BY <replaceable class="parameter">sorted_args</replaceable>)</function>
+       </entry>
+       <entry>
+        <type>double precision</type>
+       </entry>
+      </row>
+ 
+      <row>
+       <entry>
+        <indexterm>
+         <primary>cume_dist</primary>
+         <secondary>hypothetical</secondary>
+        </indexterm>
+        <function>cume_dist(<replaceable class="parameter">args</replaceable>) WITHIN GROUP (ORDER BY <replaceable class="parameter">sorted_args</replaceable>)</function>
+       </entry>
+       <entry>
+        <type>double precision</type>
+       </entry>
+      </row>
+ 
+     </tbody>
+    </tgroup>
+   </table>
+ 
+   <para>
+     For all hypothetical set functions, the list of arguments given
+     by <replaceable>args</replaceable> should match the number and types of
+     arguments given as <replaceable>sorted_args</replaceable>.
+   </para>
+ 
+   <para>
+     All of the functions listed in
+     <xref linkend="functions-hypothetical-table"> are associated with a
+     window function defined in
+     <xref linkend="functions-window">.  In each case, the function result
+     represents the value that the associated window function would have
+     returned, for the hypothetical row constructed from
+     <replaceable>args</replaceable> and included in the sorted group of
+     rows.
+    </para>
+ 
+  </sect1>
+ 
   <sect1 id="functions-window">
    <title>Window Functions</title>
  
*** a/doc/src/sgml/ref/alter_aggregate.sgml
--- b/doc/src/sgml/ref/alter_aggregate.sgml
***************
*** 21,32 **** PostgreSQL documentation
  
   <refsynopsisdiv>
  <synopsis>
! ALTER AGGREGATE <replaceable>name</replaceable> ( [ <replaceable>argmode</replaceable> ] [ <replaceable>arg_name</replaceable> ] <replaceable>arg_data_type</replaceable> [ , ... ] )
    RENAME TO <replaceable>new_name</replaceable>
  ALTER AGGREGATE <replaceable>name</replaceable> ( [ <replaceable>argmode</replaceable> ] [ <replaceable>arg_name</replaceable> ] <replaceable>arg_data_type</replaceable> [ , ... ] )
    OWNER TO <replaceable>new_owner</replaceable>
  ALTER AGGREGATE <replaceable>name</replaceable> ( [ <replaceable>argmode</replaceable> ] [ <replaceable>arg_name</replaceable> ] <replaceable>arg_data_type</replaceable> [ , ... ] )
    SET SCHEMA <replaceable>new_schema</replaceable>
  </synopsis>
   </refsynopsisdiv>
  
--- 21,37 ----
  
   <refsynopsisdiv>
  <synopsis>
! ALTER AGGREGATE
    RENAME TO <replaceable>new_name</replaceable>
  ALTER AGGREGATE <replaceable>name</replaceable> ( [ <replaceable>argmode</replaceable> ] [ <replaceable>arg_name</replaceable> ] <replaceable>arg_data_type</replaceable> [ , ... ] )
    OWNER TO <replaceable>new_owner</replaceable>
  ALTER AGGREGATE <replaceable>name</replaceable> ( [ <replaceable>argmode</replaceable> ] [ <replaceable>arg_name</replaceable> ] <replaceable>arg_data_type</replaceable> [ , ... ] )
    SET SCHEMA <replaceable>new_schema</replaceable>
+ 
+ <phrase>where <replaceable>aggregate_signature</replaceable> is one of:</phrase>
+ 
+ <replaceable>name</replaceable> ( * | [ <replaceable>argmode</replaceable> ] [ <replaceable>arg_name</replaceable> ] <replaceable>arg_data_type</replaceable> [ , ... ] )
+ <replaceable>name</replaceable> ( [ [ <replaceable>argmode</replaceable> ] [ <replaceable>arg_name</replaceable> ] <replaceable>arg_data_type</replaceable> [ , ... ] ] ) WITHIN GROUP ( * | [ <replaceable>argmode</replaceable> ] [ <replaceable>arg_name</replaceable> ] <replaceable>arg_data_type</replaceable> [ , ... ] )
  </synopsis>
   </refsynopsisdiv>
  
***************
*** 148,157 **** ALTER AGGREGATE myavg(integer) OWNER TO joe;
    </para>
  
    <para>
!    To move the aggregate function <literal>myavg</literal> for type
!    <type>integer</type> into schema <literal>myschema</literal>:
  <programlisting>
! ALTER AGGREGATE myavg(integer) SET SCHEMA myschema;
  </programlisting></para>
   </refsect1>
  
--- 153,163 ----
    </para>
  
    <para>
!    To move the ordered set function <literal>mypercentile</literal> with
!    direct argument of type <type>float8</type> taking groups
!    of <type>integer</type> type into schema <literal>myschema</literal>:
  <programlisting>
! ALTER AGGREGATE mypercentile(float8) WITHIN GROUP (integer) SET SCHEMA myschema;
  </programlisting></para>
   </refsect1>
  
*** a/doc/src/sgml/ref/alter_extension.sgml
--- b/doc/src/sgml/ref/alter_extension.sgml
***************
*** 30,36 **** ALTER EXTENSION <replaceable class="PARAMETER">name</replaceable> DROP <replacea
  
  <phrase>where <replaceable class="PARAMETER">member_object</replaceable> is:</phrase>
  
!   AGGREGATE <replaceable class="PARAMETER">agg_name</replaceable> ( [ <replaceable class="parameter">argmode</replaceable> ] [ <replaceable class="parameter">argname</replaceable> ] <replaceable class="parameter">agg_type</replaceable> [, ...] ) |
    CAST (<replaceable>source_type</replaceable> AS <replaceable>target_type</replaceable>) |
    COLLATION <replaceable class="PARAMETER">object_name</replaceable> |
    CONVERSION <replaceable class="PARAMETER">object_name</replaceable> |
--- 30,36 ----
  
  <phrase>where <replaceable class="PARAMETER">member_object</replaceable> is:</phrase>
  
!   AGGREGATE <replaceable class="PARAMETER">agg_name</replaceable> ( [ <replaceable class="parameter">argmode</replaceable> ] [ <replaceable class="parameter">argname</replaceable> ] <replaceable class="parameter">agg_type</replaceable> [, ...] ) [ WITHIN GROUP ( * | [ <replaceable class="parameter">argmode</replaceable> ] [ <replaceable class="parameter">argname</replaceable> ] <replaceable class="parameter">agg_type</replaceable> [, ...] ) ] |
    CAST (<replaceable>source_type</replaceable> AS <replaceable>target_type</replaceable>) |
    COLLATION <replaceable class="PARAMETER">object_name</replaceable> |
    CONVERSION <replaceable class="PARAMETER">object_name</replaceable> |
*** a/doc/src/sgml/ref/comment.sgml
--- b/doc/src/sgml/ref/comment.sgml
***************
*** 23,29 **** PostgreSQL documentation
  <synopsis>
  COMMENT ON
  {
!   AGGREGATE <replaceable class="PARAMETER">agg_name</replaceable> ( [ <replaceable class="parameter">argmode</replaceable> ] [ <replaceable class="parameter">argname</replaceable> ] <replaceable class="parameter">agg_type</replaceable> [, ...] ) |
    CAST (<replaceable>source_type</replaceable> AS <replaceable>target_type</replaceable>) |
    COLLATION <replaceable class="PARAMETER">object_name</replaceable> |
    COLUMN <replaceable class="PARAMETER">relation_name</replaceable>.<replaceable class="PARAMETER">column_name</replaceable> |
--- 23,29 ----
  <synopsis>
  COMMENT ON
  {
!   AGGREGATE <replaceable class="PARAMETER">agg_name</replaceable> ( [ <replaceable class="parameter">argmode</replaceable> ] [ <replaceable class="parameter">argname</replaceable> ] <replaceable class="parameter">agg_type</replaceable> [, ...] ) [ WITHIN GROUP ( * | [ <replaceable class="parameter">argmode</replaceable> ] [ <replaceable class="parameter">argname</replaceable> ] <replaceable class="parameter">agg_type</replaceable> [, ...] ) ] |
    CAST (<replaceable>source_type</replaceable> AS <replaceable>target_type</replaceable>) |
    COLLATION <replaceable class="PARAMETER">object_name</replaceable> |
    COLUMN <replaceable class="PARAMETER">relation_name</replaceable>.<replaceable class="PARAMETER">column_name</replaceable> |
*** a/doc/src/sgml/ref/create_aggregate.sgml
--- b/doc/src/sgml/ref/create_aggregate.sgml
***************
*** 29,34 **** CREATE AGGREGATE <replaceable class="parameter">name</replaceable> ( [ <replacea
--- 29,43 ----
      [ , SORTOP = <replaceable class="PARAMETER">sort_operator</replaceable> ]
  )
  
+ CREATE AGGREGATE <replaceable class="parameter">name</replaceable> ( [ <replaceable class="parameter">argmode</replaceable> ] [ <replaceable class="parameter">arg_name</replaceable> ] <replaceable class="parameter">arg_data_type</replaceable> [ , ... ] ) WITHIN GROUP ( * | [ <replaceable class="parameter">argmode</replaceable> ] [ <replaceable class="parameter">arg_name</replaceable> ] <replaceable class="parameter">arg_data_type</replaceable> [ , ... ] ) (
+     FINALFUNC = <replaceable class="PARAMETER">ffunc</replaceable>
+     [ , STRICT ]
+     [ , HYPOTHETICAL ]
+     [ , STYPE = <replaceable class="PARAMETER">state_data_type</replaceable> ]
+     [ , INITCOND = <replaceable class="PARAMETER">initial_condition</replaceable> ]
+     [ , TRANSSORTOP = <replaceable class="PARAMETER">state_sort_operator</replaceable> ]
+ )
+ 
  <phrase>or the old syntax</phrase>
  
  CREATE AGGREGATE <replaceable class="PARAMETER">name</replaceable> (
***************
*** 70,76 **** CREATE AGGREGATE <replaceable class="PARAMETER">name</replaceable> (
    </para>
  
    <para>
!    An aggregate function is made from one or two ordinary
     functions:
     a state transition function
     <replaceable class="PARAMETER">sfunc</replaceable>,
--- 79,85 ----
    </para>
  
    <para>
!    An ordinary aggregate function is made from one or two ordinary
     functions:
     a state transition function
     <replaceable class="PARAMETER">sfunc</replaceable>,
***************
*** 165,170 **** SELECT col FROM tab ORDER BY col USING sortop LIMIT 1;
--- 174,187 ----
    </para>
  
    <para>
+    The <literal>WITHIN GROUP</literal> syntax denotes a special subset of
+    aggregate functions collectively called <quote>ordered set
+    functions</quote>. These functions operate over groups of sorted values
+    in order-dependent ways. As such, they are constructed differently; there
+    is no state transition function, but the final function is required.
+   </para>
+ 
+   <para>
     To be able to create an aggregate function, you must
     have <literal>USAGE</literal> privilege on the argument types, the state
     type, and the return type, as well as <literal>EXECUTE</literal> privilege
***************
*** 278,283 **** SELECT col FROM tab ORDER BY col USING sortop LIMIT 1;
--- 295,305 ----
        aggregate's result, and the return type is <replaceable
        class="PARAMETER">state_data_type</replaceable>.
       </para>
+      <para>
+       For ordered set functions, the function arguments must instead
+       correspond to the input arguments (both direct and grouped) plus
+       the state type if any.
+      </para>
      </listitem>
     </varlistentry>
  
***************
*** 305,310 **** SELECT col FROM tab ORDER BY col USING sortop LIMIT 1;
--- 327,365 ----
       </para>
      </listitem>
     </varlistentry>
+ 
+    <varlistentry>
+     <term><replaceable class="PARAMETER">state_sort_operator</replaceable></term>
+     <listitem>
+      <para>
+       For ordered set functions only, this is a sort operator that can be
+       applied to
+       the <replaceable class="PARAMETER">state_data_type</replaceable>.
+       This is just an operator name (possibly schema-qualified).
+      </para>
+     </listitem>
+    </varlistentry>
+ 
+    <varlistentry>
+     <term><literal>STRICT</literal></term>
+     <listitem>
+      <para>
+       For ordered set functions only, this flag specifies that the function is
+       strict, i.e. that grouped rows containing nulls are skipped.
+      </para>
+     </listitem>
+    </varlistentry>
+ 
+    <varlistentry>
+     <term><literal>HYPOTHETICAL</literal></term>
+     <listitem>
+      <para>
+       For ordered set functions only, this flag specifies that the aggregate
+       parameters are to be processed according to the requirements for
+       hypothetical set functions.
+      </para>
+     </listitem>
+    </varlistentry>
    </variablelist>
  
    <para>
*** a/doc/src/sgml/ref/drop_aggregate.sgml
--- b/doc/src/sgml/ref/drop_aggregate.sgml
***************
*** 21,29 **** PostgreSQL documentation
  
   <refsynopsisdiv>
  <synopsis>
! DROP AGGREGATE [ IF EXISTS ]
!   <replaceable class="parameter">name</replaceable> ( [ <replaceable class="parameter">argmode</replaceable> ] [ <replaceable class="parameter">arg_name</replaceable> ] <replaceable class="parameter">arg_data_type</replaceable> [ , ... ] )
    [ CASCADE | RESTRICT ]
  </synopsis>
   </refsynopsisdiv>
  
--- 21,33 ----
  
   <refsynopsisdiv>
  <synopsis>
! DROP AGGREGATE [ IF EXISTS ] <replaceable class="parameter">aggregate_signature</replaceable>
    [ CASCADE | RESTRICT ]
+ 
+ <phrase>where <replaceable>aggregate_signature</replaceable> is one of:</phrase>
+ 
+ <replaceable>name</replaceable> ( * | [ <replaceable>argmode</replaceable> ] [ <replaceable>arg_name</replaceable> ] <replaceable>arg_data_type</replaceable> [ , ... ] )
+ <replaceable>name</replaceable> ( [ [ <replaceable>argmode</replaceable> ] [ <replaceable>arg_name</replaceable> ] <replaceable>arg_data_type</replaceable> [ , ... ] ] ) WITHIN GROUP ( * | [ <replaceable>argmode</replaceable> ] [ <replaceable>arg_name</replaceable> ] <replaceable>arg_data_type</replaceable> [ , ... ] )
  </synopsis>
   </refsynopsisdiv>
  
*** a/doc/src/sgml/ref/security_label.sgml
--- b/doc/src/sgml/ref/security_label.sgml
***************
*** 25,31 **** SECURITY LABEL [ FOR <replaceable class="PARAMETER">provider</replaceable> ] ON
  {
    TABLE <replaceable class="PARAMETER">object_name</replaceable> |
    COLUMN <replaceable class="PARAMETER">table_name</replaceable>.<replaceable class="PARAMETER">column_name</replaceable> |
!   AGGREGATE <replaceable class="PARAMETER">agg_name</replaceable> ( [ <replaceable class="parameter">argmode</replaceable> ] [ <replaceable class="parameter">argname</replaceable> ] <replaceable class="parameter">agg_type</replaceable> [, ...] ) |
    DATABASE <replaceable class="PARAMETER">object_name</replaceable> |
    DOMAIN <replaceable class="PARAMETER">object_name</replaceable> |
    EVENT TRIGGER <replaceable class="PARAMETER">object_name</replaceable> |
--- 25,31 ----
  {
    TABLE <replaceable class="PARAMETER">object_name</replaceable> |
    COLUMN <replaceable class="PARAMETER">table_name</replaceable>.<replaceable class="PARAMETER">column_name</replaceable> |
!   AGGREGATE <replaceable class="PARAMETER">agg_name</replaceable> ( [ <replaceable class="parameter">argmode</replaceable> ] [ <replaceable class="parameter">argname</replaceable> ] <replaceable class="parameter">agg_type</replaceable> [, ...] ) [ WITHIN GROUP ( * | [ <replaceable class="parameter">argmode</replaceable> ] [ <replaceable class="parameter">argname</replaceable> ] <replaceable class="parameter">agg_type</replaceable> [, ...] ) ] |
    DATABASE <replaceable class="PARAMETER">object_name</replaceable> |
    DOMAIN <replaceable class="PARAMETER">object_name</replaceable> |
    EVENT TRIGGER <replaceable class="PARAMETER">object_name</replaceable> |
*** a/doc/src/sgml/syntax.sgml
--- b/doc/src/sgml/syntax.sgml
***************
*** 1706,1711 **** SELECT string_agg(a ORDER BY a, ',') FROM table;  -- incorrect
--- 1706,1759 ----
     </para>
    </sect2>
  
+   <sect2 id="syntax-orderedset">
+    <title>Ordered Set Functions</title>
+ 
+    <indexterm zone="syntax-orderedset">
+     <primary>ordered set function</primary>
+    </indexterm>
+ 
+    <indexterm zone="syntax-orderedset">
+     <primary>aggregate function</primary>
+     <secondary>ordered set function</secondary>
+    </indexterm>
+ 
+    <indexterm zone="syntax-orderedset">
+     <primary>WITHIN GROUP</primary>
+    </indexterm>
+ 
+    <para>
+     An <firstterm>ordered set function</firstterm> is a particular kind of
+     aggregate function which is applied to sorted groups of values and returns
+     a single result for each group which may be influenced by the sort
+     order. Like all aggregate functions, it reduces multiple inputs to a
+     single output value; typical ordered set functions return a percentile
+     extracted from the ordered group, or the rank a specified value would have
+     within that group.  The syntax of an ordered set function is:
+ 
+ <synopsis>
+ <replaceable>function_name</replaceable> ( [ <replaceable>expression</replaceable> [ , ... ] ] ) WITHIN GROUP ( <replaceable>order_by_clause</replaceable> ) [ FILTER ( WHERE <replaceable>filter_clause</replaceable> ) ]
+ </synopsis>
+ 
+     where <replaceable>function_name</replaceable> is a previously
+     defined ordered set function (possibly qualified with a schema name) and
+     <replaceable>expression</replaceable> is any value expression that does
+     not itself contain an aggregate expression, a window function call, or any
+     reference to ungrouped columns of the source data.  The
+     mandatory <replaceable>order_by_clause</replaceable> has the same syntax
+     as for a query-level <literal>ORDER BY</> clause, as described
+     in <xref linkend="queries-order">, except that its expressions are always
+     just expressions and cannot be output-column names or numbers.  The
+     expressions of the <replaceable>order_by_clause</replaceable> may, and
+     almost invariably do, refer to the ungrouped columns of the input; the
+     clause defines the grouped input to the function. The optional
+     <replaceable>filter_clause</replaceable> is identical to that for
+     aggregate functions (see <xref linkend="syntax-aggregates">, and is applied
+     to input rows prior to the sort operation.
+    </para>
+ 
+   </sect2>
+ 
    <sect2 id="syntax-window-functions">
     <title>Window Function Calls</title>
  
*** a/doc/src/sgml/xaggr.sgml
--- b/doc/src/sgml/xaggr.sgml
***************
*** 9,28 ****
    </indexterm>
  
    <para>
!    Aggregate functions  in <productname>PostgreSQL</productname>
!    are expressed in terms of <firstterm>state values</firstterm>
!    and <firstterm>state transition functions</firstterm>.
!    That is, an aggregate operates using a state value that is updated
!    as each successive input row is processed.
!    To define a new aggregate
!    function, one selects a data type for the state value,
!    an initial value for the state, and a state transition
!    function.  The state transition function is just an
!    ordinary function that could also be used outside the
!    context of the aggregate.  A <firstterm>final function</firstterm>
!    can also be specified, in case the desired result of the aggregate
!    is different from the data that needs to be kept in the running
!    state value.
    </para>
  
    <para>
--- 9,25 ----
    </indexterm>
  
    <para>
!    Aggregate functions (other than ordered set functions)
!    in <productname>PostgreSQL</productname> are expressed in terms
!    of <firstterm>state values</firstterm> and <firstterm>state transition
!    functions</firstterm>.  That is, an aggregate operates using a state value
!    that is updated as each successive input row is processed.  To define a new
!    aggregate function, one selects a data type for the state value, an initial
!    value for the state, and a state transition function.  The state transition
!    function is just an ordinary function that could also be used outside the
!    context of the aggregate.  A <firstterm>final function</firstterm> can also
!    be specified, in case the desired result of the aggregate is different from
!    the data that needs to be kept in the running state value.
    </para>
  
    <para>
